---
# Intro gitlab file to give a basic demo of what pipelines are and what they look like

# stages: 
#   - code_quality
#   - test
#   - build
#   - integration_test
#   - deploy

# quality:
#   stage: code_quality
#   script:
#     - echo "Stage passed"

# test:
#   stage: test
#   script:
#     - echo "Stage passed"

# build:
#   stage: build
#   script:
#     - echo "Stage passed"

# integration_test:
#   stage: integration_test
#   script:
#     - echo "Stage passed"

# deploy:
#   stage: deploy
#   script:
#     - echo "Stage passed"

------------------------------------


# Working code needs the below before the gitlab ci yml will work

###################
# Dockerfile

#syntax=docker/dockerfile:1

# FROM python:3.8-slim-buster
# WORKDIR /app
# COPY . .
# CMD ["python3", "calculator.py"]

#####################
# calculator.py


# def addition(a,b):
#   total = a + b
#   return total


# def subtraction(a,b):
#     value = a - b
#     return value


# def multiplication(a,b):
#     value = a * b
#     return value


# def division(a,b):
#     value = a / b
#     return value

# a = 10
# b = 5

# add_func = (addition(a,b))
# sub_func = (subtraction(a,b))
# times_func = (multiplication(a,b))
# div_func = (division(a,b))

# print(f"The value of {a} + {b} is {add_func}")
# print(f"The value of {a} - {b} is {sub_func}")
# print(f"The value of {a} * {b} is {times_func}")
# print(f"The value of {a} / {b} is {div_func}")

##########################
# test_calculator.py

# from calculator import addition, subtraction, multiplication, division

# def test_addition():
#     x = addition(1,1)
#     assert x == 2

# def test_subtraction():
#     x = subtraction(1,1)
#     assert x == 0


# def test_multiplcation():
#     x = multiplication(1,1)
#     assert x == 1


# def test_division():
#     x = division(1,1)
#     assert x == 1





# Complete gitlab ci file
---

stages: 
  - lint
  - test
  - build
  - run

services: 
  - docker:dind

lint:
  stage: lint
  image: python:3.10-slim
  allow_failure: true
  script:
    - pip install flake8
    - flake8 calculator.py test_calculator.py


python_test:
  stage: test
  image: python:3.10-slim
  script:
    - pip install pytest
    - pytest test_calculator.py


docker_build:
  stage: build
  image: docker:latest
  script:
    - docker build --tag calculator_app .
    - docker save -o calculator_app.tar calculator_app
  artifacts:
    paths:
      - calculator_app.tar

run_app:
  stage: run
  image: docker:latest
  script:
    - docker load -i calculator_app.tar
    - docker run calculator_app